clear
I = imread('eight.tif');
imshow(I)

% Add noise
J = imnoise(I,'salt & pepper',0.02);
figure, imshow(J)

% Mean filter
K = filter2(fspecial('average',3),J)/255;
figure, imshow(K)

%Median filter
L = medfilt2(J,[3 3]);
figure, imshow(L)


%Thresholding
f=imread('groceries.jpg'); 
f=rgb2gray(f); 
imhist(f); 
f2=max(f,0.4); % remove all values below 0.4 
imshow(f); 
figure; imshow(f2); 


%Adaptative filtering for speckle noise
f1=imnoise(f,'speckle',0.04); 
f2=wiener2(f1,[7 7]); 
figure; imshow(f); 
figure; imshow(f1); 
figure; imshow(f2); 

%Histogram Equalization
I = imread('pout.tif');
J = histeq(I);
figure(1);
subplot(1,2,1);
imshow(I);
subplot(1,2,2);
imshow(J);
figure(2);
subplot(1,2,1);
imhist(I,64);
subplot(1,2,2);
imhist(J,64);

%Resizing an image
%Y=imresize(X,rows,cols,method);   %method -nearest bilinear, bicubic

[X,map]=imread ('groceries.jpg');
Y=imresize(X,[100,200],'bicubic');    %method -nearest bilinear, bicubic
imshow(Y);       



% - Box kernel for image smoothing
I1 = imread('groceries.jpg');
I2 = rgb2gray(I1);
h=ones(7)/49;
I6=uint8(conv2(I2,h,'same'));
figure;imshow(I6);

% - Separable kernels
% - Computing derivatives
close all;
keyboard;
M=magic(7)
f1=[1;-1] % vertical gradient
f2=[-1 1] % horizontal gradient
a=conv2(double(M),f1,'same')
b=conv2(double(a),f2,'same')
f3=f1*f2
c=conv2(double(M),f3,'same')
sum(sum(abs(b-c)))

% - Forward, backward and central difference     (I showed Alper's 5415 slide for this).
M=magic(5)
hback=[-1 1];
out=conv2(double(M),hback,'same')
hforw=[1 -1];
out=conv2(double(M),hforw,'same')
hcent=[1 0 -1];
out=conv2(double(M),hcent,'same')

% - Display derivative.
horgradI2=abs(conv2(double(I2),hcent,'same'));
figure;imshow(uint8(horgradI2));
vergradI2=abs(conv2(double(I2),hcent','same'));
figure;imshow(uint8(vergradI2));

% - Compute gradient magnitude and direction.
gradMag=sqrt(vergradI2.^2+horgradI2.^2);
figure;imshow(uint8(gradMag));
gradDir=atan2(vergradI2,horgradI2);

% - fspecial. Create arbitrary sized Gaussian kernel 
% with different sizes and variances and their effects on smoothing (over/under smooth)
hg = fspecial('gaussian', [7 7], 1);

% - Use Gaussian kernel for smoothing
I3=conv2(double(I2),hg,'same');
imshow(uint8(I3));

% - Gaussian derivative. Wrote a one line code/formula for creating a Gaussian derivative kernel, for gradient computation.
% - I emphasized Gaussian derivative and that, in general, this should be used for gradient computation of images.
gaussder = conv2(fspecial('gaussian',[7 7],4),[1 0 -1],'valid');
figure;surf(gaussder);
I4= conv2(double(I2),gaussder);
imshow(I4);

% convolution
box = ones(1,25)
smoothIx = conv2(double(I2), box);
close all;
figure; imshow(I2);
[ min(smoothIx(:)) max(smoothIx(:)) ]
figure; imshow(smoothIx, []);
box
box'
smoothI2 = conv2(smoothIx, box');
figure; imshow(smoothI2, []);

% Filtering
h = fspecial('gaussian', [1 15], 2)
figure; plot(h);
h = fspecial('gaussian', [1 50], 15)
figure; plot(h);
h = fspecial('gaussian', [1 25], 3)
smoothI2 = conv2(I2, h);
figure; imshow(smoothI2, []);
smoothI2 = conv2(I2, h');
figure; imshow(smoothI2, []);
close all;
close all; clc
h = [ -1 1 ];
derivX = conv2(double(I2), h);
figure; imshow(derivX, []);
figure; hist(derivX(:), 100);
derivY = conv2(double(I2), h');
figure; imshow(derivY, []);
%gradMag = sqrt( derivX.^2 + derivY.^2 );
whos
close all;
derivX = conv2(double(I2), h, 'same');
derivY = conv2(double(I2), h','same');
gradMag = sqrt( derivX.^2 + derivY.^2 );
figure; imshow(gradMag,[]);
figure; imshow(I2);
 